package com.sample;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import javax.persistence.EntityManagerFactory;

import org.kie.api.runtime.manager.RuntimeEnvironmentBuilder;
import org.jbpm.services.task.identity.JBossUserGroupCallbackImpl;
import org.kie.api.io.ResourceType;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeEnvironmentBuilder.Factory;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.manager.RuntimeManagerFactory;
import org.kie.api.runtime.process.ProcessInstance;
import org.kie.api.runtime.process.WorkItem;
import org.kie.api.runtime.process.WorkItemHandler;
import org.kie.api.runtime.process.WorkItemManager;
import org.kie.api.task.TaskService;
import org.kie.api.task.model.TaskSummary;
import org.kie.internal.io.ResourceFactory;
import org.kie.internal.runtime.manager.RuntimeEnvironment;
import org.kie.internal.runtime.manager.context.EmptyContext;
import org.kie.internal.task.api.UserGroupCallback;

/**
 * This is a sample file to launch a process.
 */
public class ProcessMainNoPersistence {

//    private static EntityManagerFactory emf;

    public static final void main(String[] args) throws Exception {
        
        RuntimeManager manager = getRuntimeManager("sample.bpmn", "AccessProcVarAndFacts.drl");
        RuntimeEngine runtime = manager.getRuntimeEngine(EmptyContext.get());
        KieSession ksession = runtime.getKieSession();

        // start a new process instance
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("firstName", "TestFirstName");
        params.put("secondName", "TestSecondName");
        ProcessInstance pi = ksession.startProcess("com.sample.bpmn.hello", params);
        System.out.println("A process instance started : pid = " + pi.getId());
        ksession.fireAllRules();
        ksession.dispose();
        manager.close();
        System.exit(0);
        
    }

    private static RuntimeManager getRuntimeManager(String process, String rule) {

        org.kie.api.runtime.manager.RuntimeEnvironment environment = ((RuntimeEnvironmentBuilder) RuntimeEnvironmentBuilder.Factory.get())    		
        		.persistence(false)
        		.userGroupCallback(null)
                .addAsset(ResourceFactory.newClassPathResource("com/sample/"+process), ResourceType.BPMN2)
                .addAsset(ResourceFactory.newClassPathResource("com/sample/"+rule), ResourceType.DRL)
                .get();
        
        return RuntimeManagerFactory.Factory.get().newPerProcessInstanceRuntimeManager(environment);

    }
}